Package org.apache.commons.configuration2.io

## Class FileSystemLocationStrategy

- java.lang.Object
- - org.apache.commons.configuration2.io.FileSystemLocationStrategy

- All Implemented Interfaces:
    `FileLocationStrategy`

      public class FileSystemLocationStrategy
      extends Object
      implements FileLocationStrategy

  A specialized implementation of `FileLocationStrategy` which uses the passed in `FileSystem` to locate a file.

  This strategy implementation ignores the URL of the passed in `FileLocator` and operates on its base path and file name. These properties are passed to the `locateFromURL()` method of `FileSystem`. So the burden of resolving the file is delegated to the `FileSystem`.

  Since:
    2.0

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `FileSystemLocationStrategy()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `URL` | `locate​(FileSystem fileSystem, FileLocator locator)` | Tries to locate the specified file.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### FileSystemLocationStrategy

          public FileSystemLocationStrategy()

  - ### Method Detail

    - #### locate

          public URL locate​(FileSystem fileSystem,
                            FileLocator locator)

      Tries to locate the specified file. The method also expects the `FileSystem` to be used. Note that the `FileLocator` object may also contain a `FileSystem`, but this is optional. The passed in `FileSystem` should be used, and callers must not pass a null reference for this argument. A concrete implementation has to evaluate the properties stored in the `FileLocator` object and try to match them to an existing file. If this can be done, a corresponding URL is returned. Otherwise, result is null. Implementations should not throw an exception (unless parameters are null) as there might be alternative strategies which can find the file in question. This implementation delegates to the `FileSystem`.
      Specified by:
        `locate` in interface `FileLocationStrategy`
      Parameters:
        `fileSystem` - the `FileSystem` to be used for this operation
        `locator` - the object describing the file to be located
      Returns:
        a URL pointing to the referenced file if location was successful; null if the file could not be resolved